<?php

namespace App\Services\Part;

use RuntimeException;
use App\Models\Part\CSModel;
use App\Helpers\Part\CSHelper;
use App\Forms\Part\CSForm;
use App\Entities\Part\CSEntity;
use App\Entities\Equipment\ServerPartEntity;

class CSService extends PartType2Service
{
    protected string $formClass = CSForm::class;
    protected string $helperClass = CSHelper::class;

    public function __construct(CSModel $model)
    {
        parent::__construct($model);
        $this->addClassPaths('CS');
    }
    public function getEntityClass(): string
    {
        return CSEntity::class;
    }
    //기본 기능부분
    protected function getEntity_process(mixed $entity): CSEntity
    {
        return $entity;
    }
    //List 검색용
    //FormFilter 조건절 처리
    //검색어조건절처리
    //OrderBy 처리(INET_ATON() 함수를 사용)
    public function setOrderBy(mixed $field = null, mixed $value = null): void
    {
        $this->model->orderBy("INET_ATON(ip) ASC");
        parent::setOrderBy($field, $value);
    }

    //서버파트관련 작업
    //파트정보가져오기
    public function getPartEntityByServerPart(ServerPartEntity $serverPartEntity): CSEntity
    {
        //IP정보에서 해당하는 IP가 있으면 가져와서 사용중인지 체크 후 수정
        $entity = $this->getEntity($serverPartEntity->getPartUid());
        if (!$entity instanceof CSEntity) {
            throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 {$serverPartEntity->getPartUid()}에 해당하는 CS정보를 찾을수없습니다.");
        }
        return $entity;
    }
}
